/**
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.scheme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.xtext.example.mydsl.scheme.Any;
import org.xtext.example.mydsl.scheme.Conditional;
import org.xtext.example.mydsl.scheme.Define;
import org.xtext.example.mydsl.scheme.Lambda;
import org.xtext.example.mydsl.scheme.Operation;
import org.xtext.example.mydsl.scheme.SchemePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Any</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.AnyImpl#getAnyID <em>Any ID</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.AnyImpl#getAnyInt <em>Any Int</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.AnyImpl#getAnyString <em>Any String</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.AnyImpl#getAnyDefine <em>Any Define</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.AnyImpl#getAnyLambda <em>Any Lambda</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.AnyImpl#getAnyOperation <em>Any Operation</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.AnyImpl#getAnyConditional <em>Any Conditional</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AnyImpl extends MinimalEObjectImpl.Container implements Any
{
  /**
   * The default value of the '{@link #getAnyID() <em>Any ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyID()
   * @generated
   * @ordered
   */
  protected static final String ANY_ID_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getAnyID() <em>Any ID</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyID()
   * @generated
   * @ordered
   */
  protected String anyID = ANY_ID_EDEFAULT;

  /**
   * The default value of the '{@link #getAnyInt() <em>Any Int</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyInt()
   * @generated
   * @ordered
   */
  protected static final int ANY_INT_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getAnyInt() <em>Any Int</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyInt()
   * @generated
   * @ordered
   */
  protected int anyInt = ANY_INT_EDEFAULT;

  /**
   * The default value of the '{@link #getAnyString() <em>Any String</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyString()
   * @generated
   * @ordered
   */
  protected static final String ANY_STRING_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getAnyString() <em>Any String</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyString()
   * @generated
   * @ordered
   */
  protected String anyString = ANY_STRING_EDEFAULT;

  /**
   * The cached value of the '{@link #getAnyDefine() <em>Any Define</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyDefine()
   * @generated
   * @ordered
   */
  protected Define anyDefine;

  /**
   * The cached value of the '{@link #getAnyLambda() <em>Any Lambda</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyLambda()
   * @generated
   * @ordered
   */
  protected Lambda anyLambda;

  /**
   * The cached value of the '{@link #getAnyOperation() <em>Any Operation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyOperation()
   * @generated
   * @ordered
   */
  protected Operation anyOperation;

  /**
   * The cached value of the '{@link #getAnyConditional() <em>Any Conditional</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAnyConditional()
   * @generated
   * @ordered
   */
  protected Conditional anyConditional;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnyImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SchemePackage.Literals.ANY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getAnyID()
  {
    return anyID;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setAnyID(String newAnyID)
  {
    String oldAnyID = anyID;
    anyID = newAnyID;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_ID, oldAnyID, anyID));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getAnyInt()
  {
    return anyInt;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setAnyInt(int newAnyInt)
  {
    int oldAnyInt = anyInt;
    anyInt = newAnyInt;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_INT, oldAnyInt, anyInt));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getAnyString()
  {
    return anyString;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setAnyString(String newAnyString)
  {
    String oldAnyString = anyString;
    anyString = newAnyString;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_STRING, oldAnyString, anyString));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Define getAnyDefine()
  {
    return anyDefine;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetAnyDefine(Define newAnyDefine, NotificationChain msgs)
  {
    Define oldAnyDefine = anyDefine;
    anyDefine = newAnyDefine;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_DEFINE, oldAnyDefine, newAnyDefine);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setAnyDefine(Define newAnyDefine)
  {
    if (newAnyDefine != anyDefine)
    {
      NotificationChain msgs = null;
      if (anyDefine != null)
        msgs = ((InternalEObject)anyDefine).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_DEFINE, null, msgs);
      if (newAnyDefine != null)
        msgs = ((InternalEObject)newAnyDefine).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_DEFINE, null, msgs);
      msgs = basicSetAnyDefine(newAnyDefine, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_DEFINE, newAnyDefine, newAnyDefine));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Lambda getAnyLambda()
  {
    return anyLambda;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetAnyLambda(Lambda newAnyLambda, NotificationChain msgs)
  {
    Lambda oldAnyLambda = anyLambda;
    anyLambda = newAnyLambda;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_LAMBDA, oldAnyLambda, newAnyLambda);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setAnyLambda(Lambda newAnyLambda)
  {
    if (newAnyLambda != anyLambda)
    {
      NotificationChain msgs = null;
      if (anyLambda != null)
        msgs = ((InternalEObject)anyLambda).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_LAMBDA, null, msgs);
      if (newAnyLambda != null)
        msgs = ((InternalEObject)newAnyLambda).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_LAMBDA, null, msgs);
      msgs = basicSetAnyLambda(newAnyLambda, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_LAMBDA, newAnyLambda, newAnyLambda));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Operation getAnyOperation()
  {
    return anyOperation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetAnyOperation(Operation newAnyOperation, NotificationChain msgs)
  {
    Operation oldAnyOperation = anyOperation;
    anyOperation = newAnyOperation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_OPERATION, oldAnyOperation, newAnyOperation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setAnyOperation(Operation newAnyOperation)
  {
    if (newAnyOperation != anyOperation)
    {
      NotificationChain msgs = null;
      if (anyOperation != null)
        msgs = ((InternalEObject)anyOperation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_OPERATION, null, msgs);
      if (newAnyOperation != null)
        msgs = ((InternalEObject)newAnyOperation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_OPERATION, null, msgs);
      msgs = basicSetAnyOperation(newAnyOperation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_OPERATION, newAnyOperation, newAnyOperation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Conditional getAnyConditional()
  {
    return anyConditional;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetAnyConditional(Conditional newAnyConditional, NotificationChain msgs)
  {
    Conditional oldAnyConditional = anyConditional;
    anyConditional = newAnyConditional;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_CONDITIONAL, oldAnyConditional, newAnyConditional);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setAnyConditional(Conditional newAnyConditional)
  {
    if (newAnyConditional != anyConditional)
    {
      NotificationChain msgs = null;
      if (anyConditional != null)
        msgs = ((InternalEObject)anyConditional).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_CONDITIONAL, null, msgs);
      if (newAnyConditional != null)
        msgs = ((InternalEObject)newAnyConditional).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchemePackage.ANY__ANY_CONDITIONAL, null, msgs);
      msgs = basicSetAnyConditional(newAnyConditional, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.ANY__ANY_CONDITIONAL, newAnyConditional, newAnyConditional));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SchemePackage.ANY__ANY_DEFINE:
        return basicSetAnyDefine(null, msgs);
      case SchemePackage.ANY__ANY_LAMBDA:
        return basicSetAnyLambda(null, msgs);
      case SchemePackage.ANY__ANY_OPERATION:
        return basicSetAnyOperation(null, msgs);
      case SchemePackage.ANY__ANY_CONDITIONAL:
        return basicSetAnyConditional(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SchemePackage.ANY__ANY_ID:
        return getAnyID();
      case SchemePackage.ANY__ANY_INT:
        return getAnyInt();
      case SchemePackage.ANY__ANY_STRING:
        return getAnyString();
      case SchemePackage.ANY__ANY_DEFINE:
        return getAnyDefine();
      case SchemePackage.ANY__ANY_LAMBDA:
        return getAnyLambda();
      case SchemePackage.ANY__ANY_OPERATION:
        return getAnyOperation();
      case SchemePackage.ANY__ANY_CONDITIONAL:
        return getAnyConditional();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SchemePackage.ANY__ANY_ID:
        setAnyID((String)newValue);
        return;
      case SchemePackage.ANY__ANY_INT:
        setAnyInt((Integer)newValue);
        return;
      case SchemePackage.ANY__ANY_STRING:
        setAnyString((String)newValue);
        return;
      case SchemePackage.ANY__ANY_DEFINE:
        setAnyDefine((Define)newValue);
        return;
      case SchemePackage.ANY__ANY_LAMBDA:
        setAnyLambda((Lambda)newValue);
        return;
      case SchemePackage.ANY__ANY_OPERATION:
        setAnyOperation((Operation)newValue);
        return;
      case SchemePackage.ANY__ANY_CONDITIONAL:
        setAnyConditional((Conditional)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.ANY__ANY_ID:
        setAnyID(ANY_ID_EDEFAULT);
        return;
      case SchemePackage.ANY__ANY_INT:
        setAnyInt(ANY_INT_EDEFAULT);
        return;
      case SchemePackage.ANY__ANY_STRING:
        setAnyString(ANY_STRING_EDEFAULT);
        return;
      case SchemePackage.ANY__ANY_DEFINE:
        setAnyDefine((Define)null);
        return;
      case SchemePackage.ANY__ANY_LAMBDA:
        setAnyLambda((Lambda)null);
        return;
      case SchemePackage.ANY__ANY_OPERATION:
        setAnyOperation((Operation)null);
        return;
      case SchemePackage.ANY__ANY_CONDITIONAL:
        setAnyConditional((Conditional)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.ANY__ANY_ID:
        return ANY_ID_EDEFAULT == null ? anyID != null : !ANY_ID_EDEFAULT.equals(anyID);
      case SchemePackage.ANY__ANY_INT:
        return anyInt != ANY_INT_EDEFAULT;
      case SchemePackage.ANY__ANY_STRING:
        return ANY_STRING_EDEFAULT == null ? anyString != null : !ANY_STRING_EDEFAULT.equals(anyString);
      case SchemePackage.ANY__ANY_DEFINE:
        return anyDefine != null;
      case SchemePackage.ANY__ANY_LAMBDA:
        return anyLambda != null;
      case SchemePackage.ANY__ANY_OPERATION:
        return anyOperation != null;
      case SchemePackage.ANY__ANY_CONDITIONAL:
        return anyConditional != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (anyID: ");
    result.append(anyID);
    result.append(", anyInt: ");
    result.append(anyInt);
    result.append(", anyString: ");
    result.append(anyString);
    result.append(')');
    return result.toString();
  }

} //AnyImpl
